EDIT - bug #10084

Adding a new specimen to character matrix fails
06/28/2022 11:43 AM - Katja Luther

Status: Closed Start date:

Priority: Priority14 Due date:

Assignee: Katja Luther % Done: 90%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.32

Severity: normal Found in Version:

Description

The following exception appears when trying to save the character matrix after adding a new specimen:

last remote method : https://api.cybertaxonomy.org:443/caryophyllales_spp/remoting/descriptivedata
set.service
last remote request client time : 2022-06-28T11:42:29.155
last remote request response header time : Tue, 28 Jun 2022 09:42:29 GMT
client error time : 2022-06-28T11:42:29.48
login : admin
editor version : 5.30.0
server : api.cybertaxonomy.org (cybertaxonomy.org) / caryophyllales_spp
schema version : 5.29.0.0.20211122
os : Windows Server 2012 R2 6.3 amdé64
java : 1.8.0_131
org.eclipse.ed.core.di.InjectionException: java.lang.NullPointerException
at org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:65)
at org.eclipse.ed.core.internal.di.InjectorImpl.invokeUsingClass (InjectorImpl. java:282)
at org.eclipse.ed.core.internal.di.InjectorImpl.invoke (InjectorImpl. java:247)
at org.eclipse.ed.core.contexts.ContextInjectionFactory.invoke (ContextInjectionFactory. java:90

at org.eclipse.e4d.ui.internal.workbench.PartServiceSaveHandler.save (PartServiceSaveHandler. jav
a:57)

at org.eclipse.ui.internal.WorkbenchWindow$7.save (WorkbenchWindow. java:594)

at org.eclipse.ed.ui.internal.workbench.PartServiceImpl.savePart (PartServiceImpl.java:1390)

at eu.etaxonomy.taxeditor.workbench.SaveHandler.execute (SaveHandler. java:38)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor. java:55)

at org.eclipse.ed.core.internal.di.InjectorImpl.invokeUsingClass (InjectorImpl. java:282)

at org.eclipse.ed.core.internal.di.InjectorImpl.invoke (InjectorImpl.java:264)

at org.eclipse.ed.core.contexts.ContextInjectionFactory.invoke (ContextInjectionFactory.java:13

at org.eclipse.ed.core.commands.internal.HandlerServiceHandler.execute (HandlerServiceHandler. j
ava:152)

at org.eclipse.core.commands.Command.executeWithChecks (Command. java:494)

at org.eclipse.core.commands.ParameterizedCommand.executeWithChecks (ParameterizedCommand. java:
488)

at org.eclipse.ed.core.commands.internal.HandlerServiceImpl.executeHandler (HandlerServiceImpl.
java:210)

at org.eclipse.ed.ui.workbench.renderers.swt.HandledContributionItem.executeltem (HandledContri
butionItem. java:433)

at org.eclipse.e4d.ui.workbench.renderers.swt.AbstractContributionItem.handleWidgetSelection (Ab
stractContributionItem. java:454)

at org.eclipse.ed.ui.workbench.renderers.swt.AbstractContributionItem$3.handleEvent (AbstractCo
ntributionItem. java:482)

at org.eclipse.swt.widgets.EventTable.sendEvent (EventTable. java:84)

at org.eclipse.swt.widgets.Display.sendEvent (Display.java:4418)

at org.eclipse.swt.widgets.Widget.sendEvent (Widget. java:1079)

at org.eclipse.swt.widgets.Display.runDeferredEvents (Display.java:4236)

at org.eclipse.swt.widgets.Display.readAndDispatch (Display.java:3824)
at org.eclipse.ed.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine. java
:1121)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ed.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine. java:l
022)

at org.eclipse.e4d.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)

at org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)

at eu.etaxonomy.taxeditor.Application.start (Application.java:20)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle.java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLaunc
her.java:134)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher. java:
104)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:388)

at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:243)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)

at org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)

at org.eclipse.equinox.launcher.Main.run (Main.java:1519)
Caused by: java.lang.NullPointerException

at eu.etaxonomy.cdm.api.service.DescriptiveDataSetService.lambda$addRowWrapperToDataset$3 (Desc
riptiveDataSetService. java:259)

at java.util.stream.ReferencePipeline$2$1.accept (ReferencePipeline. java:174)

at java.util.ArrayList$ArrayListSpliterator.tryAdvance (ArrayList.java:1359)

at java.util.stream.ReferencePipeline.forEachWithCancel (ReferencePipeline. java:126)

at java.util.stream.AbstractPipeline.copyIntoWithCancel (AbstractPipeline. java:498)

at java.util.stream.AbstractPipeline.copyInto (AbstractPipeline. java:485)

at java.util.stream.AbstractPipeline.wrapAndCopyInto (AbstractPipeline.java:471)

at java.util.stream.FindOps$FindOp.evaluateSequential (FindOps. java:152)

at java.util.stream.AbstractPipeline.evaluate (AbstractPipeline. java:234)

at java.util.stream.ReferencePipeline.findAny (ReferencePipeline.java:469)

at eu.etaxonomy.cdm.api.service.DescriptiveDataSetService.addRowWrapperToDataset (DescriptiveDa
taSetService. java:259)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.RAopUtils.invokeJoinpointUsingReflection (AopUtils.java:333)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMeth
odInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:157)

at org.springframework.transaction.interceptor.TransactionInterceptor$l.proceedWithInvocation (
TransactionInterceptor. java:99)

at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransactio
n(TransactionAspectSupport. java:283)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterc
eptor.java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:213)

at com.sun.proxy.S$Proxy725.addRowWrapperToDataset (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.aop.support.RAopUtils.invokeJoinpointUsingReflection (AopUtils.java:333)

at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint (ReflectiveMeth
odInvocation. java:190)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:157)
at org.springframework.remoting. support.RemoteInvocationTracelInterceptor.invoke (RemotelInvocati
onTracelnterceptor.java:78)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:213)

at com.sun.proxy.S$SProxyl150.addRowWrapperToDataset (Unknown Source)

at sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)

at sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.remoting.support.RemoteInvocation.invoke (RemoteInvocation. java:212)

at eu.etaxonomy.cdm.api.remoting.DebuggingRemoteInvocationExecutor.invoke (DebuggingRemotelInvoc
ationExecutor. java:52)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invoke (RemoteInvocationB
asedExporter. java:78)

at org.springframework.remoting.support.RemoteInvocationBasedExporter.invokeAndCreateResult (Re
moteInvocationBasedExporter.java:114)

at org.springframework.remoting.httpinvoker.HttpInvokerServiceExporter.handleRequest (HttpInvok
erServiceExporter. java:80)

at org.springframework.web.servlet.mvc.HttpRequestHandlerAdapter.handle (HttpRequestHandlerAdap
ter.java:51)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet.java:967)

at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet. java:901)

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet. java:970)

at org.springframework.web.servlet.FrameworkServlet.doPost (FrameworkServlet. java:872)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:707)

at org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet. java:846)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder$SNotAsyncServlet.service (ServletHolder. java:1395)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder.java:755)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler.java:1617)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:317)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.invoke (FilterSe
curityInterceptor.java:127)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doFilter (Filter
SecurityInterceptor. java:91)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.Jjava:331)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (ExceptionTransl
ationFilter.java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.Jjava:331)

at org.springframework.security.web.session.SessionManagementFilter.doFilter (SessionManagement
Filter.java:137)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.Jjava:331)

at org.springframework.security.web.servletapi.SecurityContextHolderAwareRequestFilter.doFilte
r (SecurityContextHolderAwareRequestFilter.java:170)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.Jjava:331)

at org.springframework.security.web.savedrequest.RequestCacheAwareFilter.doFilter (RequestCache
AwareFilter. java:63)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.Jjava:331)

at org.springframework.security.web.authentication.www.BasicAuthenticationFilter.doFilterInter
nal (BasicAuthenticationFilter. java:215)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.java:331)

at org.springframework.security.web.authentication.logout.LogoutFilter.doFilter (LogoutFilter.j
ava:110)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
oxy.Jjava:331)

at org.springframework.security.web.header.HeaderWriterFilter.doFilterInternal (HeaderWriterFil
ter.java:66)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)
at org.springframework.security.web.

oxy.Jjava:331)
at org.springframework.security.web.
ContextPersistenceFilter.java:105)
at org.springframework.security.web.

oxy.java:331)

at org.springframework.security.web.

FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr
context.SecurityContextPersistenceFilter.doFilter (Security
FilterChainProxy$VirtualFilterChain.doFilter (FilterChainPr

context.request.async.WebAsyncManagerIntegrationFilter.doF

ilterInternal (WebAsyncManagerIntegrationFilter. java:56)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter.java:107)

at org.springframework
ContextHandlerCollection.handle (ContextHandlerCollection. j

HandlerWrapper.handle (HandlerWrapper. java:127)

Server.handle (Server. java:500)
HttpChannel.lambda$handle$1l (HttpChannel. java:383)
HttpChannel.dispatch (HttpChannel. java:547)
HttpChannel.handle (HttpChannel. java:375)

.HttpConnection.onFillable (HttpConnection. java:270)

io.AbstractConnection$ReadCallback.succeeded (AbstractConnection. java:311)
io.FillInterest.fillable(FillInterest.java:103)
io.ChannelEndPoint$2.run (ChannelEndPoint.java:117)

util.thread.
util.thread.
util.thread.
util.thread.
util.thread.

util.thread.
util.thread.

strategy.EatWhatYouKill.runTask (EatWhatYouKill. java:336)
strategy.EatWhatYouKill.doProduce (EatWhatYouKill. java:313)
strategy.EatWhatYouKill.tryProduce (EatWhatYouKill. java:171)
strategy.EatWhatYouKill.run (EatWhatYouKill. java:129)
ReservedThreadExecutor$ReservedThread. run (ReservedThreadExecu

QueuedThreadPool.runJob (QueuedThreadPool. java:806)
QueuedThreadPool$Runner.run (QueuedThreadPool. java:938)

java.lang.Thread.run (Thread. java:748)

org.springframework.remoting.support.RemoteInvocationUtils.fillInClientStackTraceIfPossible

(RemoteInvocationUtils. java:45)

at org.springframework.remoting.support.RemoteInvocationResult.recreate (RemoteInvocationResult

.java:149)
at org.springframework.remoting.support.RemoteInvocationBasedAccessor.recreateRemotelnvocation
Result (RemoteInvocationBasedAccessor. java:85)
at

org.springframework.remoting.httpinvoker.HttpInvokerClientInterceptor.invoke (HttpInvokerCli

entInterceptor. java:158)

at

org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca

tion.java:179)

at
at
at

org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy. java:213)
com.sun.proxy.SProxy49.addRowWrapperToDataset (Unknown Source)
eu.etaxonomy.taxeditor.editor.descriptiveDataSet.matrix.CharacterMatrix.addSpecimensToDescr

iptiveDataSet (CharacterMatrix.java:996)

at

eu.etaxonomy.taxeditor.editor.descriptiveDataSet .matrix.CharacterMatrixPart.save (CharacterM

atrixPart.java:207)

at
at
at
at
at

sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:498)
org.eclipse.ed.core.internal.di.MethodRequestor.execute (MethodRequestor.java:55)

48 more

Related issues:

Copied to EDIT - task #10109: Investigate best practice for HQL with enumset New

Associated revisions

Revision bce2d0e5 - 06/28/2022 11:44 AM - Katja Luther

fix 10084: fix problem with missing taxonuuid in dto

Revision f134a838 - 07/06/2022 09:49 AM - Katja Luther

ref #10084: add type comparison to hgl again

Revision 13b70d09 - 07/29/2022 01:54 PM - Andreas Miiller

ref #10084 adapt query to TypedQuery

Revision 78d9e692 - 07/29/2022 01:54 PM - Andreas Miiller

ref #10084 revert filtering by description type in query, needs further investigation

History

#1 - 06/28/2022 11:46 AM - Katja Luther

- Status changed from New to Resolved

- % Done changed from 0 to 60

Please review.

#2 - 06/28/2022 12:57 PM - Andreas Miuller

- Assignee changed from Katja Luther to Andreas Mdiller

#3 - 07/05/2022 05:57 PM - Andreas Miiller

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther

Generally the bug seems to be fixed and the ticket can be closed.

Only the handling of descriptionType in the code changes | do not fully understand/like. Loading all data and then filtering by type does not seem to
be the most performant way. Isn't it possible to use a like-search eg. parameter like "%#AGG#%" or something similar? Have you tested this and it
does not work or is the current solution a quick-fix to get the search running at all?

If it is a quick-fix we should create a new ticket for this related issue, | guess.

#4 - 07/06/2022 09:50 AM - Katja Luther

- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

Andreas Muller wrote in #note-3:
Generally the bug seems to be fixed and the ticket can be closed.

Only the handling of descriptionType in the code changes | do not fully understand/like. Loading all data and then filtering by type does not seem
to be the most performant way. Isn't it possible to use a like-search eg. parameter like "%#AGG#%" or something similar? Have you tested this
and it does not work or is the current solution a quick-fix to get the search running at all?

If it is a quick-fix we should create a new ticket for this related issue, | guess.

Sometimes it needs a break, than a better solution could be found. | solved it with ":descriptionType IN d.types"
#5 - 07/06/2022 10:00 AM - Andreas Miiller
Katja Luther wrote in #note-4:
Sometimes it needs a break, than a better solution could be found. | solved it with ":descriptionType IN d.types"

Did you test this, or better is there a test that proves that it works? | asked because types is an enum of termtype which is mapped to hibernate via a
self-written usertype. Therefore | doubt that it works like an ordinary collection.

#6 - 07/06/2022 10:00 AM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

#7 - 07/07/2022 12:44 PM - Katja Luther

Katja Luther wrote in #note-4:

Andreas Muller wrote in #note-3:

Generally the bug seems to be fixed and the ticket can be closed.

Only the handling of descriptionType in the code changes | do not fully understand/like. Loading all data and then filtering by type does not
seem to be the most performant way. Isn't it possible to use a like-search eg. parameter like "%#AGG#%" or something similar? Have you
tested this and it does not work or is the current solution a quick-fix to get the search running at all?

If it is a quick-fix we should create a new ticket for this related issue, | guess.

Sometimes it needs a break, than a better solution could be found. | solved it with ":descriptionType IN d.types"

Neither "LIKE '#AGG" (types is not of type string) nor the "IN d.types" works, so | would come back to the workaround implementation as long as we
do not have a better solution.

#8 - 07/26/2022 11:13 PM - Andreas Miuller

- Assignee changed from Katja Luther to Andreas Mdiller

#9 - 07/29/2022 08:50 PM - Andreas Miiller
- Copied to task #10109: Investigate best practice for HQL with enumset added

#10 - 07/29/2022 08:53 PM - Andreas Miiller
- Status changed from Feedback to Resolved
- Priority changed from Highest to Priority14

- % Done changed from 60 to 90

It looked to me as you did not yet revert, so | tried to do this by 78d9e692 . Please review. | already checked on nightly and adding a specimen still
works.

| created a new ticket for the filter by description type issue which is not really related to this ticket as a description type filter does not exist here.

We can close the ticket after your final review.

#11 - 07/29/2022 08:53 PM - Andreas Miiller

- Assignee changed from Andreas Muiller to Katja Luther
#12 - 08/23/2022 12:31 PM - Katja Luther

- Status changed from Resolved to Closed

Everything ok.
